



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iOS学习笔记--Quartz2D</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iOS学习笔记--Quartz2D</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 03:24:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<blockquote><p>Quartz 2D是一个二维绘图引擎，同时支持iOS和Mac系统。</p>
<p><strong>Quartz 2D能完成的工作：</strong> <br /><br />
  1. 绘制图形 : 线条\三角形\矩形\圆\弧等 <br /><br />
  2. 绘制文字 <br /><br />
  3. 绘制\生成图片(图像) <br /><br />
  4. 读取\生成PDF <br /><br />
  5. 截图\裁剪图片 <br /><br />
  6. 自定义UI控件等</p></blockquote>
<p>为了便于搭建美观的UI界面，iOS提供了UIKit框架，里面有各种各样的UI控件，利用UIKit框架提供的控件，能搭建和现实一些简单、常见的UI界面。但是，有些UI界面极其复杂、而且比较个性化，用普通的UI控件无法实现，这时可以利用Quartz2D技术将控件内部的结构画出来，自定义控件的样子。其实，iOS中大部分控件的内容都是通过Quartz2D画出来的，因此，Quartz2D在iOS开发中很重要的一个价值是：自定义view（自定义UI控件）。</p>
<h3>图形上下文</h3>
<blockquote><p>图形上下文（Graphics Context）：是一个CGContextRef类型的数据</p></blockquote>
<p><strong>图形上下文的作用：</strong> <br /><br />
1. 保存绘图信息、绘图状态 <br /><br />
2. 决定绘制的输出目标（绘制到什么地方）（输出目标可以是PDF文件、Bitmap或者显示器的窗口上） <br /><br />
3. 相同的一套绘图序列，指定不同的Graphics Context，就可将相同的图像绘制到不同的目标上</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161211194336192?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvemhhbmdrZTMwMTY=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161211194412152?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvemhhbmdrZTMwMTY=/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast"></p>
<blockquote><p>**Bitmap Graphics Context <br /><br />
  PDF Graphics Context <br /><br />
  Window Graphics Context <br /><br />
  Layer Graphics Context <br /><br />
  Printer Graphics Context**</p></blockquote>
<h3>自定义view</h3>
<blockquote><p>利用Quartz2D绘制东西到view上: <br /><br />
  1. 要有图形上下文，因为它能保存绘图信息，并且决定着绘制到什么地方去 <br /><br />
  2. 那个图形上下文必须跟view相关联，才能将内容绘制到view上面</p></blockquote>
<p><strong>自定义view的步骤</strong></p>
<ol><li>新建一个类，继承自UIView</li>
<li>实现- (void)drawRect:(CGRect)rect方法，然后在这个方法中取得跟当前view相关联的图形上下文绘制相应的图形内容，利用图形上下文将绘制的所有内容渲染显示到view上面</li></ol>
<p><strong>drawRect:</strong></p>
<ol><li><p>为什么要实现drawRect:方法才能绘图到view上？ <br /><br />
因为在drawRect:方法中才能取得跟view相关联的图形上下文</p></li>
<li><p>drawRect:方法在什么时候被调用？ <br /><br />
当view第一次显示到屏幕上时（被加到UIWindow上显示出来） <br /><br />
调用view的setNeedsDisplay或者setNeedsDisplayInRect:时。</p></li></ol>
<p>Quartz2D的API是纯C语言的，Quartz2D的API来自于Core Graphics框架。数据类型和函数基本都以CG作为前缀如：CGContextRef、CGPathRef、CGContextStrokePath(ctx)。</p>
<p>在drawRect:方法中取得上下文后，就可以绘制东西到view上。View内部有个layer（图层）属性，drawRect:方法中取得的是一个Layer Graphics Context，因此，绘制的东西其实是绘制到view的layer上去了。View之所以能显示东西，完全是因为它内部的layer。</p>
<p><strong>Quartz2D绘图的代码步骤</strong></p>
<pre class="prettyprint linenums"><code>1. 获得图形上下文
CGContextRef ctx = UIGraphicsGetCurrentContext();

2. 拼接路径（下面代码是搞一条线段）
CGContextMoveToPoint(ctx, 10, 10);
CGContextAddLineToPoint(ctx, 100, 100);

3. 绘制路径
CGContextStrokePath(ctx); // CGContextFillPath(ctx);</code></pre>
<p><strong>常用路径函数</strong></p>
<pre class="prettyprint linenums"><code>//新建一个起点
void CGContextMoveToPoint(CGContextRef c, CGFloat x, CGFloat y)

//添加新的线段到某个点
void CGContextAddLineToPoint(CGContextRef c, CGFloat x, CGFloat y)

//添加一个矩形
void CGContextAddRect(CGContextRef c, CGRect rect)

//添加一个椭圆
void CGContextAddEllipseInRect(CGContextRef context, CGRect rect)

//添加一个圆弧
void CGContextAddArc(CGContextRef c, CGFloat x, CGFloat y,
  CGFloat radius, CGFloat startAngle, CGFloat endAngle, int clockwise)
//一般以CGContextDraw、CGContextStroke、CGContextFill开头的函数，都是用来绘制路径的
//Mode参数决定绘制的模式
void CGContextDrawPath(CGContextRef c, CGPathDrawingMode mode)

//绘制空心路径
void CGContextStrokePath(CGContextRef c)

//绘制实心路径
void CGContextFillPath(CGContextRef c)</code></pre>
<p>如，画一条线：</p>
<pre class="prettyprint linenums"><code>- (void)drawRect:(CGRect)rect
{
       //获取上下文
    CGContextRef ctx = UIGraphicsGetCurrentContext();

    //创建路径
    CGMutablePathRef path = CGPathCreateMutable();

    //绘制路径
    CGPathMoveToPoint(path, NULL, 50, 50);

    CGPathAddLineToPoint(path, NULL, 100,100);
    //添加路径至上下文
    CGContextAddPath(ctx, path);
    //渲染上下文
    CGContextStrokePath(ctx);
}</code></pre>
<p>绘制曲线：</p>
<pre class="prettyprint linenums"><code>- (void)drawRect:(CGRect)rect {
    //绘制曲线
    // 获取上下文
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    // 描述路径
    // 设置起点
    CGContextMoveToPoint(ctx, 50, 50);
    // cpx:控制点的x
    CGContextAddQuadCurveToPoint(ctx, 150, 20, 250, 50);
    // 渲染上下文
    CGContextStrokePath(ctx);
}</code></pre>
<p>常见属性使用：</p>
<pre class="prettyprint linenums"><code>- (void)drawRect:(CGRect)rect {
     // 获取上下文
    CGContextRef ctx = UIGraphicsGetCurrentContext();
    // 描述路径
    //起点
    CGContextMoveToPoint(ctx, 50, 50);
    CGContextAddLineToPoint(ctx, 100, 50);
    // 设置起点
    CGContextMoveToPoint(ctx, 80, 60);
    // 默认下一根线的起点就是上一根线终点
    CGContextAddLineToPoint(ctx, 100, 200);
    // 设置绘图状态,一定要在渲染之前
    // 颜色
    [[UIColor redColor] setStroke];
    // 线宽
    CGContextSetLineWidth(ctx, 5);
    // 设置连接样式
    CGContextSetLineJoin(ctx, kCGLineJoinBevel);
    // 设置顶角样式
    CGContextSetLineCap(ctx, kCGLineCapRound);
    // 渲染上下文
    CGContextStrokePath(ctx);
}</code></pre>
<p><strong>图形上下文栈的操作</strong></p>
<ol><li>将当前的上下文copy一份,保存到栈顶(那个栈叫做”图形上下文栈”) <br /><br />
<strong>void CGContextSaveGState(CGContextRef c)</strong></li>
<li>将栈顶的上下文出栈,替换掉当前的上下文 <br /><br />
<strong>void CGContextRestoreGState(CGContextRef c)</strong></li></ol>
<p>感觉有点类似Android中的canvas.save()与canvas.restore();</p>
<p><strong>矩阵操作</strong></p>
<p>利用矩阵操作，能让绘制到上下文中的所有路径一起发生变化 <br /><br />
1. 缩放 <br /><br />
<strong>void CGContextScaleCTM(CGContextRef c, CGFloat sx, CGFloat sy)</strong> <br /><br />
2. 旋转 <br /><br />
<strong>void CGContextRotateCTM(CGContextRef c, CGFloat angle)</strong> <br /><br />
3. 平移 <br /><br />
<strong>void CGContextTranslateCTM(CGContextRef c, CGFloat tx, CGFloat ty)</strong></p>
<p>感觉可以和Android中<code>canvas.scale()</code>、<code>canvas.translate()</code>、<code>canvas.rotate()</code>相比较，将当前上下文进行缩放旋转和平移操作。</p>
<p><strong>实现案例：</strong></p>
<p>1、图片水印： <br /><br />
实现方式：利用Quartz2D，将水印（文字、LOGO）画到图片的右下角</p>
<pre class="prettyprint linenums"><code>开启一个基于位图的图形上下文
void UIGraphicsBeginImageContextWithOptions(CGSize size, BOOL opaque, CGFloat scale)

从上下文中取得图片（UIImage）
UIImage* UIGraphicsGetImageFromCurrentImageContext();

结束基于位图的图形上下文
void UIGraphicsEndImageContext();</code></pre>
<pre class="prettyprint linenums"><code> // 加载图片
    UIImage *image = [UIImage imageNamed:@"阿狸"];

    // 0.获取上下文，之前的上下文都是在view的drawRect方法中获取（跟View相关联的上下文layer上下文）
    // 目前我们需要绘制图片到新的图片上，因此需要用到位图上下文

    // 怎么获取位图上下文,注意位图上下文的获取方式跟layer上下文不一样。位图上下文需要我们手动创建。

    // 开启一个位图上下文，注意位图上下文跟view无关联，所以不需要在drawRect.
    // size:位图上下文的尺寸（新图片的尺寸）
    // opaque: 不透明度 YES：不透明 NO:透明，通常我们一般都弄透明的上下文
    // scale:通常不需要缩放上下文，取值为0，表示不缩放
    UIGraphicsBeginImageContextWithOptions(image.size, NO, 0);
    // 1.绘制原生的图片
    [image drawAtPoint:CGPointZero];

    // 2.给原生的图片添加文字
    NSString *str = @"MrZk";

    // 创建字典属性
    NSMutableDictionary *dict = [NSMutableDictionary dictionary];
    dict[NSForegroundColorAttributeName] = [UIColor redColor];
    dict[NSFontAttributeName] = [UIFont systemFontOfSize:20];

    [str drawAtPoint:CGPointMake(200, 528) withAttributes:dict];

    // 3.生成一张图片给我们,从上下文中获取图片
    UIImage *imageWater = UIGraphicsGetImageFromCurrentImageContext();

    // 4.关闭上下文
    UIGraphicsEndImageContext();
    _imageView.image = imageWater;</code></pre>
<p>2、 图片裁剪</p>
<pre class="prettyprint linenums"><code>- (void)clipImage
{
    // 0.加载图片
    UIImage *image = [UIImage imageNamed:@"阿狸头像"];

    // 1.开启位图上下文，跟图片尺寸一样大
    UIGraphicsBeginImageContextWithOptions(image.size, NO, 0);

    // 2.设置圆形裁剪区域，正切与图片
    // 2.1创建圆形的路径
    UIBezierPath *path = [UIBezierPath bezierPathWithOvalInRect:CGRectMake(0, 0, image.size.width, image.size.height)];

    // 2.2把路径设置为裁剪区域
    [path addClip];

    // 3.绘制图片
    [image drawAtPoint:CGPointZero];

    // 4.从上下文中获取图片
    UIImage *clipImage = UIGraphicsGetImageFromCurrentImageContext();

    // 5.关闭上下文
    UIGraphicsEndImageContext();

    _imageView.image = clipImage;
}
</code></pre>
<p>3、屏幕截屏</p>
<pre class="prettyprint linenums"><code>// 开启位图上下文
    UIGraphicsBeginImageContextWithOptions(view.bounds.size, NO, 0);

    // 获取上下文
    CGContextRef ctx = UIGraphicsGetCurrentContext();

    // 把控件上的图层渲染到上下文,layer只能渲染
    [view.layer renderInContext:ctx];

    // 生成一张图片
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();

    // 关闭上下文
    UIGraphicsEndImageContext();
</code></pre>
<p>4、图片擦除</p>
<pre class="prettyprint linenums"><code>// 获取当前点
    CGPoint curP = [pan locationInView:self.view];

    // 获取擦除的矩形范围
    CGFloat wh = 100;
    CGFloat x = curP.x - wh * 0.5;
    CGFloat y = curP.y - wh * 0.5;

    CGRect rect = CGRectMake(x, y, wh, wh);

    // 开启上下文
    UIGraphicsBeginImageContextWithOptions(self.view.bounds.size, NO, 0);

    CGContextRef ctx = UIGraphicsGetCurrentContext();

    // 控件的layer渲染上去
    [_imageView.layer renderInContext:ctx];

    // 擦除图片
    CGContextClearRect(ctx, rect);

    // 生成一张图片
    UIImage *image = UIGraphicsGetImageFromCurrentImageContext();

    _imageView.image = image;

    // 关闭上下文
    UIGraphicsEndImageContext();
</code></pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/eoqvly8x.html">SQL Server镜像自动生成脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdxd68.html">des &lpar;C语言&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gy4wz9.html">jquery send&lpar;data&rpar; 对data的处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q752kg9.html">GsonWithoutObject 没有对象&lpar;脱离对象&rpar; 直接提取 &period;&period;&period; gson json</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8epllj9.html">rank 和 星星评级</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0xv08.html">java接收键盘输入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmvrzx9.html">Codeforces Round &num;277 &lpar;Div&period; 2&rpar; D&period; Valid Sets 暴力</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4g5j8.html">python 自动化之路 day 01&period;1 数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wzo2wq.html">CentOS&plus;nginx&plus;uwsgi&plus;Python 多站点环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2y079.html">Hadoop学习历程（一、编译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy12yw2q.html">python 日历</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxego8.html">public &amp;lt&semi;T&amp;gt&semi; void method&lpar;T var&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo4mydq.html">MongoDB--架构搭建（主从、副本集）之副本集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj02579.html">ajax得到后端数据一直提示为&lbrack;object Object&rsqb;解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4xeme9.html">c&sol;c&plus;&plus;本地时间获取</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53yneq.html">Spark记录-大数据简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rgxdn9.html">【liunx】sftp常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjx1069.html">mysql 删除数据库中所有的表中的数据，只删database下面所有的表。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mje4508.html">赋值操作符、复制构造函数、析构函数、static成员练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv5kx8.html">python len&lpar;&rpar; 函数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj63vk8.html">kafka知识体系-kafka设计和原理分析-消息传递语义</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m0owo8.html">QueryRunner--常见方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd616z9.html">&lbrack;HNOI 2015&rsqb;开店</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2je77v8.html">bzoj1272 Gate Of Babylon</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pnjl48.html">NOIP 2009 最优贸易</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eykenz9.html">●SPOJ 7258 Lexicographical Substring Search</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me42prq.html">AR8033 1000M模式下ping包丢包率过大分析与解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me42krq.html">面试&lpar;二&rpar;---synchronized</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjenkx8.html">TensorFlow LSTM 注意力机制图解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy13v72q.html">curl支持HTTP和https</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
